<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Media Server: media_framework.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Media Server
   &#160;<span id="projectnumber">1.0</span>
   </div>
   <div id="projectbrief">Simple MediaServer with effects and filters</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('media__framework_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">media_framework.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="media__framework_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Prelude_8hpp.html">Prelude.hpp</a>&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="classMediaBlackbox.html">   18</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMediaBlackbox.html">MediaBlackbox</a></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;{</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;  <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <a class="code" href="classgst_1_1Element.html">gst::Element</a> source;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <a class="code" href="classgst_1_1Element.html">gst::Element</a> video_balance;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <a class="code" href="classgst_1_1Element.html">gst::Element</a> audio_convert;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <a class="code" href="classgst_1_1Element.html">gst::Element</a> video_convert;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <a class="code" href="classgst_1_1Element.html">gst::Element</a> audio_resample;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <a class="code" href="classgst_1_1Element.html">gst::Element</a> videosink;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <a class="code" href="classgst_1_1Element.html">gst::Element</a> audiosink;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <a class="code" href="classgst_1_1Pipeline.html">gst::Pipeline</a> pipeline;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    std::string current_path; <span class="comment">// TODO: Maybe wrapper around callback ?</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classMediaBlackbox.html#afcaba1d1bbd3bcec069ac5d8f110ef2e">decode_pad_added_handler</a>(GstElement *src, GstPad *new_pad, <a class="code" href="classMediaBlackbox.html">MediaBlackbox</a> *data);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;  <span class="keyword">public</span>:</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <a class="code" href="classMediaBlackbox.html#a9fc612bd5058aaccc9134e2965a5b125">MediaBlackbox</a>();</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span> set_saturation(<span class="keywordtype">double</span> saturation);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMediaBlackbox.html#a91b00710fe30dc390c6a10d697ed2693">start_media</a>();</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMediaBlackbox.html#a2aab2cedb799e30419eb1892e02dfb11">pause_media</a>();</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMediaBlackbox.html#af26eb9f26f51ac6ec06b7c9314bf3ab4">stop_media</a>();</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMediaBlackbox.html#a62c6e8f750e5ed03862f6b09c3ec9811">set_media_src</a>(std::string file_path);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMediaBlackbox.html#ada1c5730f5e98336a63ff22abcbd1ea6">bus_loop</a>();</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    gst::State <a class="code" href="classMediaBlackbox.html#aa267457fa1d640a4a92da0588b875454">get_pipeline_state</a>();</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;};</div>
<div class="ttc" id="aPrelude_8hpp_html"><div class="ttname"><a href="Prelude_8hpp.html">Prelude.hpp</a></div><div class="ttdoc">Includes call C++ Wrappers for Gstreamer.</div></div>
<div class="ttc" id="aclassMediaBlackbox_html"><div class="ttname"><a href="classMediaBlackbox.html">MediaBlackbox</a></div><div class="ttdoc">Media API class Creates a pipeline internally and provides methods to start, stop and set media sourc...</div><div class="ttdef"><b>Definition:</b> media_framework.hpp:19</div></div>
<div class="ttc" id="aclassMediaBlackbox_html_a2aab2cedb799e30419eb1892e02dfb11"><div class="ttname"><a href="classMediaBlackbox.html#a2aab2cedb799e30419eb1892e02dfb11">MediaBlackbox::pause_media</a></div><div class="ttdeci">void pause_media()</div><div class="ttdoc">pause playing the currently selected media source (pausing)</div><div class="ttdef"><b>Definition:</b> media_framework.cpp:68</div></div>
<div class="ttc" id="aclassMediaBlackbox_html_a62c6e8f750e5ed03862f6b09c3ec9811"><div class="ttname"><a href="classMediaBlackbox.html#a62c6e8f750e5ed03862f6b09c3ec9811">MediaBlackbox::set_media_src</a></div><div class="ttdeci">void set_media_src(std::string file_path)</div><div class="ttdoc">Setting the currently selected.</div><div class="ttdef"><b>Definition:</b> media_framework.cpp:91</div></div>
<div class="ttc" id="aclassMediaBlackbox_html_a91b00710fe30dc390c6a10d697ed2693"><div class="ttname"><a href="classMediaBlackbox.html#a91b00710fe30dc390c6a10d697ed2693">MediaBlackbox::start_media</a></div><div class="ttdeci">void start_media()</div><div class="ttdoc">Start playing the currently set media source.</div><div class="ttdef"><b>Definition:</b> media_framework.cpp:56</div></div>
<div class="ttc" id="aclassMediaBlackbox_html_a9fc612bd5058aaccc9134e2965a5b125"><div class="ttname"><a href="classMediaBlackbox.html#a9fc612bd5058aaccc9134e2965a5b125">MediaBlackbox::MediaBlackbox</a></div><div class="ttdeci">MediaBlackbox()</div><div class="ttdoc">Creates elements to build our pipeline with and links all audio and video elements.</div><div class="ttdef"><b>Definition:</b> media_framework.cpp:29</div></div>
<div class="ttc" id="aclassMediaBlackbox_html_aa267457fa1d640a4a92da0588b875454"><div class="ttname"><a href="classMediaBlackbox.html#aa267457fa1d640a4a92da0588b875454">MediaBlackbox::get_pipeline_state</a></div><div class="ttdeci">gst::State get_pipeline_state()</div><div class="ttdoc">Get the Pipeline State (according to enum values)</div><div class="ttdef"><b>Definition:</b> media_framework.cpp:200</div></div>
<div class="ttc" id="aclassMediaBlackbox_html_ada1c5730f5e98336a63ff22abcbd1ea6"><div class="ttname"><a href="classMediaBlackbox.html#ada1c5730f5e98336a63ff22abcbd1ea6">MediaBlackbox::bus_loop</a></div><div class="ttdeci">void bus_loop()</div><div class="ttdoc">listens to bus</div><div class="ttdef"><b>Definition:</b> media_framework.cpp:167</div></div>
<div class="ttc" id="aclassMediaBlackbox_html_af26eb9f26f51ac6ec06b7c9314bf3ab4"><div class="ttname"><a href="classMediaBlackbox.html#af26eb9f26f51ac6ec06b7c9314bf3ab4">MediaBlackbox::stop_media</a></div><div class="ttdeci">void stop_media()</div><div class="ttdoc">stop the pipeline and set its state to Null Needs to be called at the end of main function</div><div class="ttdef"><b>Definition:</b> media_framework.cpp:81</div></div>
<div class="ttc" id="aclassMediaBlackbox_html_afcaba1d1bbd3bcec069ac5d8f110ef2e"><div class="ttname"><a href="classMediaBlackbox.html#afcaba1d1bbd3bcec069ac5d8f110ef2e">MediaBlackbox::decode_pad_added_handler</a></div><div class="ttdeci">static void decode_pad_added_handler(GstElement *src, GstPad *new_pad, MediaBlackbox *data)</div><div class="ttdoc">Callback handler for the added pad on uridecodebin.</div><div class="ttdef"><b>Definition:</b> media_framework.cpp:118</div></div>
<div class="ttc" id="aclassgst_1_1Element_html"><div class="ttname"><a href="classgst_1_1Element.html">gst::Element</a></div><div class="ttdoc">C++ Wrapper around.</div><div class="ttdef"><b>Definition:</b> Element.hpp:32</div></div>
<div class="ttc" id="aclassgst_1_1Pipeline_html"><div class="ttname"><a href="classgst_1_1Pipeline.html">gst::Pipeline</a></div><div class="ttdef"><b>Definition:</b> Pipeline.hpp:9</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_a7bb9b575703809b9fbb7ad7f723668f.html">local_app</a></li><li class="navelem"><a class="el" href="dir_81b007610a59bc1f4a5ed448a6168bbb.html">media_framework</a></li><li class="navelem"><a class="el" href="dir_6663f9701dfef3280c6153a761bfda2e.html">include</a></li><li class="navelem"><a class="el" href="media__framework_8hpp.html">media_framework.hpp</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
